<!--suppress JSIncompatibleTypesComparison -->

<script lang="ts" setup>
import { sort } from '~/utils';
import type { DistroProduct, ProductVariant } from '~/utils/types';

interface Props {
  products: DistroProduct[] | null;
}
defineProps<Props>();

function averageStars(product: DistroProduct) {
  const totalReviews = product.reviews.length;
  if (totalReviews === 0) return 0;

  const totalStars = product.reviews.reduce((sum, review) => sum + review.stars, 0);
  return Math.ceil(totalStars / totalReviews);
}

function startingVariantPrice(variants: ProductVariant[]) {
  const priceArray = variants
    .map((variant) => variant.price)
    .filter((price) => price !== null);

  if (priceArray.length === 0) {
    // Handle the case when all prices are null
    return null; // You can return null or some other default value
  }

  return Math.min(...priceArray) as number;
}
</script>

<template>
  <div v-if="products" class="products max-w-container">
    <template v-for="product in products" :key="product.id">
      <NuxtLink
        v-if="!product.displayVariantsAsProducts"
        :href="`/products/${product.id}`"
        class="product"
        aria-label="View product details"
      >
        <img
          v-if="product.thumbnail"
          :src="product.thumbnail"
          :alt="product.name + ' thumbnail'"
        />
        <ImagePlaceholder v-else class="aspect-square" />
        <div class="product-content">
          <h3 v-if="product.name">{{ product.name }}</h3>
          <h3 v-else>Untitled</h3>
          <div v-if="product.reviews.length" class="flex">
            <!--suppress JSUnusedLocalSymbols -->
            <img
              v-for="number in averageStars(product)"
              src="/img/star-filled.svg"
              alt="Star"
            />
            <p class="ml-2">({{ product.reviews.length }})</p>
          </div>
          <p v-if="!product.variants.length" class="mt-1 text-lg">${{ product.price }}</p>
          <p v-else-if="startingVariantPrice(product.variants) !== null" class="mt-1 text-lg">
            ${{ startingVariantPrice(product.variants) }}+
          </p>
          <p v-else class="mt-1 text-lg">Price not available</p>
        </div>
      </NuxtLink>

      <!-- Display variants if displayVariantsAsProducts is true -->
      <NuxtLink
        v-else
        v-for="variant in product.variants"
        class="product"
        :href="`/products/${product.id}?variantId=${variant.id}`"
        :key="variant.id"
        :aria-label="'View details of ' + (variant.name || product.name)"
      >
        <img
          v-if="variant.thumbnail"
          :src="variant.thumbnail"
          :alt="variant.name + ' thumbnail'"
        />
        <ImagePlaceholder v-else class="aspect-square" />
        <div class="product-content">
          <h3 v-if="variant.name">{{ variant.name }}</h3>
          <h3 v-else>
            {{ product.name }} -
            <span v-for="(cat, index) in sort(variant.variantCategories)">
              <span v-if="index !== 0">/</span>{{ cat }}</span
            >
          </h3>
          <p v-if="variant.price" class="mt-1 text-lg">${{ variant.price }}</p>
        </div>
      </NuxtLink>
    </template>
  </div>
</template>
